unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    bnPaint: TButton;
    bnExit: TButton;
    procedure bnExitClick(Sender: TObject);
    procedure bnPaintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{================================================================}
        {= logical function, should be customized by students =}
     function F(x,y: single): boolean;
     var
       z1, z2: single;
     begin
     z1:=abs(x)+abs(y);
     z2:=(x*x+y*y);
     Result:=(z1 > 5) and (z1 < 10) xor (z2 > 25) and (z2 < 100);
     end;
{================================================================}

procedure TForm1.bnExitClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.bnPaintClick(Sender: TObject);
Const
  Cnt = 10;
var
  N,i,j,L: integer;
  x,y, dx,dy: single;
  b: boolean;
begin
  {= Select area size (in pixels) as 0.5 * min(Height, Width) =}
N:=PaintBox1.Width div 2;
i:=PaintBox1.Height div 2;
if N>i then N:=i;

   {= Select "dx" and "dy" values so as "N pixels" ~ "10 units of X" =}
L:=N div (Cnt+1);
if L<1 then L:=1;
dx:=1/L;
dy:=1/L;

  {= paint the areas =}
for i:=-N to N do
  for j:=-N to N do
    begin
    x:=i*dx;    { calculate absolute coordinates }
    y:=j*dy;

    b:=F(x,y);  { get boolean value for the (X,Y) point }

    if b        { colour the point }
    then PaintBox1.Canvas.Pixels[i+N,j+N]:=clWhite
    else PaintBox1.Canvas.Pixels[i+N,j+N]:=clBlack;
                {sample color names:
                  clBlack   clWhite
                  clRed     clGreen     clBlue
                  clPurple  clYellow    clGray
                  clNavy    clAqua      clSilver
                  clTeal    clLime      clMaroon
                  clOlive   clCream     clFuchsia
                  }
    end;

  {= draw axes =}
PaintBox1.Canvas.Pen.Color:=clFuchsia;

PaintBox1.Canvas.MoveTo(N,0);
PaintBox1.Canvas.LineTo(N,2*N);
PaintBox1.Canvas.MoveTo(0,N);
PaintBox1.Canvas.LineTo(2*N,N);

  {= draw labels on the X axis =}
for i:=1 to Cnt do
  begin
  PaintBox1.Canvas.MoveTo(N-i*L, N+2);
  PaintBox1.Canvas.LineTo(N-i*L, N-2);
  PaintBox1.Canvas.MoveTo(N+i*L, N+2);
  PaintBox1.Canvas.LineTo(N+i*L, N-2);
  end;

  {= draw labels on the Y axis =}
for i:=1 to Cnt do
  begin
  PaintBox1.Canvas.MoveTo(N+2, N-i*L);
  PaintBox1.Canvas.LineTo(N-2, N-i*L);
  PaintBox1.Canvas.MoveTo(N+2, N+i*L);
  PaintBox1.Canvas.LineTo(N-2, N+i*L);
  end;

end;

end.
